<?php
/*
	class to manage campaigns
*/

class Campagne {

	var $tbdb;	//table

	var $start;	// start row
	var $omode;	// order asc|desc
	var $oby;	// order by field
	var $ps;	// page size

	var $linkaggiungi;	// link to add
	var $linkmodifica;	// link to edit
	var $linkmodifica_label;

	var $linkeliminamarcate;	//link to delete

	var $gestore; // php handler file


	function __construct ($tbdb="7banner_campagne",$ps=20,$oby="id_campagna",$omode="desc",$start=0) {
		global $session,$root;
		$this->gestore = $_SERVER["PHP_SELF"];
		$this->tbdb = $tbdb;

		// setVariabile used GET > POST > SESSION > default value
		$this->start = setVariabile("gridStart",$start,$this->tbdb);
		$this->omode= setVariabile("gridOrderMode",$omode,$this->tbdb);
		$this->oby= setVariabile("gridOrderBy",$oby,$this->tbdb);
		$this->ps = setVariabile("gridPageSize",$ps,$this->tbdb);

		// save values in session
		if(isset($_GET['combotipo'])) $session->register($this->tbdb."combotipo",$_GET['combotipo']);
		if(isset($_GET['combotiporeset'])) $session->register($this->tbdb."combotiporeset",$_GET['combotiporeset']);

		// link above in the panel
		$this->linkaggiungi = "$this->gestore?op=aggiungi";
		$this->linkeliminamarcate = "javascript:confermaDeleteCheck(document.datagrid);";

		// link in table grid
		$this->linkmodifica = "$this->gestore?op=modifica&id=##id_campagna##";
		$this->linkmodifica_label = "modifica";

		checkAbilitazione("CAMPAGNE","SETTA_SOLO_SE_ESISTE");

	}

	// for advertiser
	function getIdCliente() {
		global $session;
		return execute_scalar("select id_cliente from ".DB_PREFIX."7banner_clienti where cd_utente='".$session->get("idutente")."'");
	}

	/*
		show campaigns grid
	*/
	function elenco($combotipo="",$combotiporeset="",$keyword="") {
		global $session;

		$html = "";

		if ($session->get("CAMPAGNE")) {
			if($combotiporeset=='reset') {
				// if changed with filter select
				// reset pagination
				$this->start = 0;
			}


			//
			// reactivate filter after save and cancel
			if($combotipo=="" && $combotiporeset=="") {
				$combotipo= setVariabile("combotipo",$combotipo,$this->tbdb);
				$combotiporeset=setVariabile("combotiporeset",$combotipo,$this->tbdb);
				$GLOBALS['combotipo']=$combotipo;
				$GLOBALS['combotiporeset']=$combotiporeset;
			}


			$t=new grid(DB_PREFIX.$this->tbdb,$this->start, $this->ps, $this->oby, $this->omode);
			$t->checkboxFormAction=$this->gestore;
			$t->checkboxFormName="datagrid";
			
			if($session->get("idprofilo")==5 && PAYMENTS!="ON") $t->checkboxForm= false;
				else $t->checkboxForm= true;
			$t->functionhtml = "";
			$t->mostraRecordTotali = true;

			$t->parametriDaPssare = "";
			if($combotipo) {
				$t->parametriDaPssare.="&combotipo=".urlencode($combotipo);
			}
			if($keyword) $t->parametriDaPssare.="&keyword=".urlencode($keyword);


			// key field id for links
			$t->chiave="id_campagna";


			// SQL
			if ($session->get("idprofilo") == 5) {

				$t->campi="id_campagna,de_titolo,fl_status,q,v";
				$t->titoli="{Campaign ID},{Campaign title},{Status},{Number of banners},{Campaign value}";
				$t->query="SELECT A.id_campagna,A.de_titolo,B.de_nome,fl_status,(SELECT count(*) from ".DB_PREFIX."7banner WHERE cd_campagna=id_campagna) q,
						(SELECT SUM(nu_price) from ".DB_PREFIX."7banner WHERE cd_campagna=id_campagna) v
						from ".$this->tbdb." as A 
						inner join ".DB_PREFIX."7banner_clienti as B on cd_cliente = id_cliente and id_cliente='".$this->getIdCliente()."'
					";

			} else {
				$t->campi="id_campagna,de_titolo,de_nome,fl_status,q,v";
				$t->titoli="{Campaign ID},{Campaign title},{Client name},{Status},{Number of banners},{Campaign value}";
				$t->query="SELECT A.id_campagna,A.de_titolo,B.de_nome,fl_status,(SELECT count(*) from ".DB_PREFIX."7banner WHERE cd_campagna=id_campagna) q,
						(SELECT SUM(nu_price) from ".DB_PREFIX."7banner WHERE cd_campagna=id_campagna) v
						from ".DB_PREFIX."".$this->tbdb." as A 
						inner join ".DB_PREFIX."7banner_clienti as B on cd_cliente = id_cliente
					";
			}

			$where = " 1=1 ";
			if($combotipo==="0" || $combotipo) {
				if($combotipo=="-999") {

				} else {
					if($where!="") { $where.= " and "; }
					$where.=" A.cd_cliente='".$combotipo."'";
				}
			}
			if($keyword) {
				if($where!="") { $where.= " and "; }
				if ($session->get("idprofilo") == 5) {
					$where.="  ((A.de_titolo like '%{$keyword}%'))";
				} else {
					$where.="  ((A.de_titolo like '%{$keyword}%') OR (B.de_nome like '%{$keyword}%'))";
				}
			}
			if($where) {
				$t->query.=" where {$where}";
			}

			$t->addScegliDaInsieme("fl_status",
				array(
					"1"=>"<span class='labelgreen'>{ON}</span>",
					"0"=>"<span class='labelred'>{OFF}</span>",
					"2"=>"<span class='labelred'>{TOTALLY OFF}</span>"
				)
			);
			$t->arFormattazioneTD=array(
				"q" => "numero",
				"v" => "numero",
			);
			$t->addCampi("v","show_campaign_value");
			$t->addCampi("de_titolo","show_campaign_title");
			$t->addComando("../7banner/index.php?op=stats&combobanner=-999|##id_campagna##","stats","{Stats}");

			$texto = $t->show();

			if (trim($texto)=="") $texto="{No records found.}";

			$html .= $texto."<br/>";

		} else {

			$html = "0";
		}
		return $html;
	}


	/*
		show campaign detail form
	*/
	function getDettaglio($id="",$duplica='no') {
		global $session,$conn;

		// if payments are not active the advertiser can't
		// create or edit campaigns
		if($session->get("idprofilo")==5 && PAYMENTS!="ON") {
			return "0";
		}

		if ($session->get("CAMPAGNE")) {
			if ($id!="") {
				/*
					modify
				*/
				$dati = $this->getDati($id);

				$action = "modificaStep2";



			} else {
				/*
					insert
				*/
				$dati = getEmptyNomiCelleAr(DB_PREFIX.$this->tbdb) ;
				$dati["fl_status"] = 1;
				$action = "aggiungiStep2";

			}

			$html = loadTemplateAndParse("template/dettaglio.html");

			$bodyclass="";
			if($session->get("idprofilo")>=20) $bodyclass .='admin ';
			if($session->get("idprofilo")==5) $bodyclass.='advertiser';


			// form construction
			$objform = new form();

			//------------------------------------------------
			//combo clients
			$sql = "select id_cliente,de_nome from ".DB_PREFIX."7banner_clienti ".
				($session->get("idprofilo")==5 ? " where id_cliente='".$this->getIdCliente()."'" : "")
				."order by de_nome";
			$rs = $conn->query($sql) or die($conn->error.$sql);
			if($rs->num_rows > 1 || $rs->num_rows == 0) $ar[""]="--{choose}--";
			while($riga = $rs->fetch_array()) $ar[$riga['id_cliente']]=$riga['de_nome'];
			$cd_cliente = new optionlist("cd_cliente",($dati["cd_cliente"]),$ar);
			$cd_cliente->obbligatorio=1;
			$cd_cliente->label="'{Client}'";
			$objform->addControllo($cd_cliente);
			//------------------------------------------------

			if($dati['fl_status']=='1') 
				$stati = array("1"=>"{ON}" ,"0"=>"{OFF}","2"=>"{TOTALLY OFF}"); 
			else $stati= array("1"=>"ON" ,"0"=>"OFF");
			$fl_status = new optionlist("fl_status",$dati["fl_status"],$stati );
			$fl_status->obbligatorio=1;
			$fl_status->label="'{Status}'";
			$objform->addControllo($fl_status);

			$de_titolo = new testo("de_titolo",$dati["de_titolo"],50,50);
			$de_titolo->obbligatorio=1;
			$de_titolo->label="'{Campaign title}'";
			$objform->addControllo($de_titolo);

			$id_obj = new hidden("id",$dati["id_campagna"]);
			$op = new hidden("op",$action);

			$html = str_replace("##STARTFORM##", $objform->startform(), $html);
			$html = str_replace("##id##", $id_obj->gettag(), $html);
			$html = str_replace("##op##", $op->gettag(), $html);
			$html = str_replace("##fl_status##", $fl_status->gettag(), $html);
			$html = str_replace("##cd_cliente##", $cd_cliente->gettag(), $html);
			$html = str_replace("##de_titolo##", $de_titolo->gettag(), $html);
			$html = str_replace("##gestore##", $this->gestore, $html);
			$html = str_replace("##ENDFORM##", $objform->endform(), $html);
			$html = str_replace("##bodyclass##", $bodyclass, $html);


		} else {
			$html = "0";
		}
		return $html;
	}

	function getDati($id) {
		return execute_row("SELECT * from ".DB_PREFIX.$this->tbdb." where id_campagna='{$id}'");
	}


	function updateAndInsert($arDati,$files) {
		// in:
		// arDati--> array _POST from the form
		// files --> array _FILES
		// result:
		//	"" --> ok
		//  "0" --> no permission
		//  "2|messaggio" --> other errors

		global $session,$conn;
		if ($session->get("CAMPAGNE")) {

			// check for payments active for advertiser
			if($session->get("idprofilo")==5 && PAYMENTS!="ON") {
				return "0";
			}

			// constrain client for advertiser
			if($session->get("idprofilo")==5) $arDati['cd_cliente'] = $this->getIdCliente();

	

			if ($arDati["id"]!="") {
				$id = $arDati["id"];
				/*
					Modify
				*/
				if($arDati["fl_status"] == 2) {
					$arDati["fl_status"] = 0;
					$sql = "update ".DB_PREFIX."7banner set fl_stato='S' where cd_campagna='".$arDati["id"]."';";
					$conn->query($sql) or die($conn->error.$sql);
				}

				$sql="UPDATE ".DB_PREFIX.$this->tbdb." set
					de_titolo='##de_titolo##',
					cd_cliente='##cd_cliente##', 
					fl_status='##fl_status##'
					where id_campagna='##id##'";
				$sql= str_replace("##cd_cliente##",$arDati["cd_cliente"],$sql);
				$sql= str_replace("##de_titolo##",$arDati["de_titolo"],$sql);
				$sql= str_replace("##fl_status##",$arDati["fl_status"],$sql);
				$sql= str_replace("##id##",$arDati["id"],$sql);
				$conn->query($sql) or die($conn->error.$sql);
				$html= "ok|".$id;
			} else {
				/*
					Insert
				*/
				$sql="INSERT into ".DB_PREFIX.$this->tbdb." (cd_cliente,de_titolo,fl_status) values('##cd_cliente##','##de_titolo##','##fl_status##')";
				$sql= str_replace("##cd_cliente##",$arDati["cd_cliente"],$sql);
				$sql= str_replace("##de_titolo##",$arDati["de_titolo"],$sql);
				$sql= str_replace("##fl_status##",$arDati["fl_status"],$sql);
				$conn->query($sql) or die($conn->error.$sql);
				$id = $conn->insert_id;
				$html= "ok|".$id;

			}



		} else {
			$html="0";		//no permission
		}
		return $html;
	}


	function getHtmlcombotipo($def="") {
		global $conn, $session;
		//------------------------------------------------
		//combo filter
		$sql = "select id_cliente,de_nome,count(*) as c from ".DB_PREFIX.$this->tbdb."
					inner join ".DB_PREFIX."7banner_clienti on cd_cliente=id_cliente 
					".($session->get("idprofilo")==5 ? "and id_cliente='".$this->getIdCliente()."'" : "" )."
					group by id_cliente";
		$rs = $conn->query($sql) or trigger_error($conn->error);
		if($rs->num_rows > 1 || $rs->num_rows == 0) $arFiltri = array("-999"=>"All");

		while($riga = $rs->fetch_array()) {
			if ($riga['id_cliente']=="") $riga['c']=0;
			$arFiltri[$riga['id_cliente']]= $riga['de_nome']." (".$riga['c'].")";
		}
		//------------------------------------------------
		$out = "";
		foreach ($arFiltri as $k => $v) { $out.="<option value='{$k}' ".(($k."x"==$def."x")?"selected":"").">{$v}</option>"; }
		return "<label><select onchange='aggiornaGriglia()' name='combotipo' id='combotipo' class='filter'>{$out}</select><input type='hidden' name='combotiporeset' id='combotiporeset'></label>";

	}


	function deleteItem($id) {
		// in:
		// id --> id tipo da cancellare
		// results:
		//	"" --> ok
		//  "0" --> no permission
		//  "-2" --> connected items

		global $session,$conn,$root;
		if ($session->get("CAMPAGNE")) {

			$q = execute_scalar("select count(1) from ".DB_PREFIX."7banner 
				inner join ".DB_PREFIX."7banner_campagne on cd_campagna=id_campagna
				inner join ".DB_PREFIX."7banner_clienti on cd_cliente=id_cliente
				where id_campagna='".$id."'");
			if($q > 0) {
				return "-2";
			}

			$sql="DELETE FROM ".DB_PREFIX."7banner_campagne where id_campagna='$id' ".
				($session->get("idprofilo")==5 ? " and cd_cliente='".$this->getIdCliente()."' " : "");
			$conn->query($sql) or trigger_error($conn->error."sql='$sql'<br>");


			$html = "";
		} else {
			$html="0";		//no permission
		}
		return $html;

	}
	function eliminaSelezionati($dati) {
		// in:
		// dati --> $_POST
		// result:
		//	"" --> ok
		//  "0" --> no permission
		//  "-2" --> connected items

		global $session;
		if ($session->get("CAMPAGNE")) {

			$html="0";

			$p=$dati['gridcheck'];
			for ($i=0;$i<count($p);$i++) {
				$risultato = $this->deleteItem($p[$i]);
				if($risultato!="") return $risultato;
			}
			$html = "";
		} else {
			$html="0";		//no permissions
		}
		return $html;
	}


}

?>